#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                                       HL_ACT.mq4 |
//|                                                                  |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v1.1 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " arzuma"
#property link      " arzuma@megalog.ru"

#property indicator_chart_window
#property indicator_color1 Red
#property indicator_buffers 2
#property indicator_color2 Lime

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double Per = 3;
extern double M_Price = 0;
extern double D = 0;
extern double NBar = 200;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];
double ExtHistoBuffer2[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

void SetIndexValue2(int shift, double value)
{
  ExtHistoBuffer2[shift] = value;
}

double GetIndexValue(int shift)
{
  return(ExtHistoBuffer[shift]);
}

double GetIndexValue2(int shift)
{
  return(ExtHistoBuffer2[shift]);
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID,1);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID,1);
   SetIndexBuffer(1, ExtHistoBuffer2);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int shift = 0;
double val = 0;
double val2 = 0;
double Pr = 0;
double PrevPr = 0;
double bar_count = 0;
string trend = "";
double n = 0;

/*[[
	Name := Hi-Lo
	Author := arzuma
	Link := arzuma@megalog.ru
	Separate Window := No
	First Color := Lime
	First Draw Type := Symbol
	First Symbol := 119
	Use Second Data := Yes
	Second Color := Red
	Second Draw Type := Symbol
	Second Symbol := 119
]]*/



SetLoopCount(0);

for(shift=NBar;shift>=0 ;shift--){ 
val=iMA(NULL, 0, Per, 1, MODE_SMA, PRICE_HIGH, shift);
val2=iMA(NULL, 0, Per, 1, MODE_SMA, PRICE_LOW, shift);
if( M_Price == 0 ) {
	if( Close[shift]<val2 && PrevPr == 1 ) Pr=0;   
	if( Close[shift]>val && PrevPr == 0 ) Pr=1;}
 else {
	if( (High[shift]+Low[shift])/2<val2 && PrevPr == 1 ) Pr=0;   
	if( (High[shift]+Low[shift])/2>val && PrevPr == 0 ) Pr=1;}

if( Pr != PrevPr ) bar_count=1 ; else bar_count+=1;
if( Pr == 1 ) trend="Up" ; else trend="Dn";
PrevPr=Pr;   
if( Pr == 0 ) {SetIndexValue(shift, High[shift]+D*Point); SetIndexValue2(shift,0);
if( GetIndexValue(shift+1) != 0 && GetIndexValue(shift+1)<High[shift]+D*Point ) 
SetIndexValue(shift,GetIndexValue(shift+1));}

if( Pr == 1 ) {SetIndexValue2(shift, Low[shift]-D*Point); SetIndexValue(shift,0);
if( GetIndexValue2(shift+1) != 0 && GetIndexValue2(shift+1)>Low[shift]-D*Point ) 
SetIndexValue2(shift,GetIndexValue2(shift+1));}
} 

  return(0);
}